// 004 u_c_display_packets
// 30 oct 2007

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit a_aa_01_interbase_dbx;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration
  ;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure connect_dbx__Click(sender: TObject; e: System.EventArgs);
    procedure dbx_reader__Click(sender: TObject; e: System.EventArgs);
    procedure listbox_fill__Click(sender: TObject; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    TextBox1: System.Web.UI.WebControls.TextBox;
    connect_dbx_: System.Web.UI.WebControls.Button;
    dbx_reader_: System.Web.UI.WebControls.Button;
  protected
    procedure OnInit(e: EventArgs); override;
  private
  public
    procedure display(p_text: String);
  end;

implementation
  uses Borland.Data.Common
  , Borland.Data.DBXCommon
;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
begin
  Include(Self.connect_dbx_.Click, Self.connect_dbx__Click);
  Include(Self.dbx_reader_.Click, Self.dbx_reader__Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        //
        // Required for Designer support
        //
        InitializeComponent;
        inherited OnInit(e);
        display('ok');
      end; // OnInit

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put user code to initialize the page here
      end; // Page_Load

    const k_connection_name= 'DBX_EMPLOYEE_7_IB_DAN';

    procedure TDefault.connect_dbx__Click(sender: TObject; e: System.EventArgs);
      var l_c_dbx_connection_factory: TDBXConnectionFactory;
          l_c_dbx_properties: TDBXProperties;
          l_c_dbx_connection: tDbxConnection;
      begin
        display('> get_dbx_connection');
        l_c_dbx_connection_factory:= TDBXConnectionFactory.GetConnectionFactory;
        l_c_dbx_properties:= l_c_dbx_connection_factory.GetConnectionProperties(k_connection_name);
        display(l_c_dbx_properties.Values['Database']);

        display('GetConnection');
        l_c_dbx_connection:= l_c_dbx_connection_factory.GetConnection(l_c_dbx_properties );

        display('< get_dbx_connection');
      end; // connect_dbx__Click

    function f_c_dbx_connection(p_connection_name: WideString): tDbxConnection;
      var l_c_dbx_connection_factory: TDBXConnectionFactory;
          l_c_dbx_properties: TDBXProperties;
      begin
        l_c_dbx_connection_factory:= TDBXConnectionFactory.GetConnectionFactory;
        l_c_dbx_properties:= l_c_dbx_connection_factory.GetConnectionProperties(p_connection_name);

        Result:= l_c_dbx_connection_factory.GetConnection(l_c_dbx_properties );
      end; // f_c_dbx_connection

    procedure TDefault.dbx_reader__Click(sender: TObject; e: System.EventArgs);
      var l_c_dbx_connection: tDbxConnection;
          l_c_dbx_command: tDbxCommand;
          l_c_dbx_reader: tDbxReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        display('> dbx_reader_');

        l_c_dbx_connection:= f_c_dbx_connection(k_connection_name);
        l_c_dbx_command:= l_c_dbx_connection.CreateCommand;
        l_c_dbx_command.Text:= 'SELECT * FROM country';
        l_c_dbx_reader:= l_c_dbx_command.ExecuteQuery;

        while l_c_dbx_reader.Next do
        begin
          l_row_display:= '  ';
          for l_column_index:= 0 to l_c_dbx_reader.ColumnCount- 1 do
            l_row_display:= l_row_display
                + l_c_dbx_reader.Value[l_column_index].GetAnsiString+ ' ';
          display(l_row_display);
        end; // while l_c_dbx_reader.Next

        display('< dbx_reader_');
      end; // dbx_reader__Click

    function f_c_dbx_reader(p_c_dbx_connection: tDbxConnection;
        p_select_request: String): tDbxReader;
        // -- receives an OPEN connection
      var l_c_dbx_connection: tDbxConnection;
          l_c_dbx_command: tDbxCommand;
      begin
        l_c_dbx_command:= p_c_dbx_connection.CreateCommand;
        l_c_dbx_command.Text:= p_select_request;
        Result:= l_c_dbx_command.ExecuteQuery;
      end; // f_c_dbx_reader

    procedure TDefault.listbox_fill__Click(sender: TObject; e: System.EventArgs);
        // NO
      var l_c_dbx_connection : tDbxConnection;
          l_c_dbx_reader: tDbxReader;
      begin
(*
        l_c_dbx_connection:= f_c_dbx_connection(k_connection_name);
        l_c_dbx_reader:= f_c_dbx_reader(l_c_dbx_connection,
            'SELECT * FROM country');

        ListBox1.DataSource:= l_c_dbx_reader;
        ListBox1.DataTextField:= 'COUNTRY';

        DataBind;
*)
      end; // listbox_fill__Click

end.

